#! /usr/bin/python
import xml.sax
import string
import time
import sys

# 
# TO generate the LaTeX format from the contents.xml
# for the book.
class myxml(xml.sax.handler.ContentHandler):
    """
         A simple XML parser SAX.
         for RSS parsing.
    """
    def processingInstruction(self,*x):
        #print "yea."+str(x)
        pass

    def characters(self,text):
        #print "chars."

        prev_space=False
        temp_str=""
        
        for i in text:
            if((i==' ' and prev_space==True) or i=='\t' or i=='\r' or i=='\n'):
                prev_space=True
                continue
            else:
                if(i==' '):
                    prev_space=True
                else:
                    prev_space=False
                temp_str=temp_str + i
            
        text=temp_str;
        if(len(text) < 2):#ignore 1 letter strings.
            return
        
        if(self.char_print_flag==True):
            if(text[0]=='\n' or text[0]=='\r'):
                return                        
            #print "data sent"
            self.print_text+=text
        return

    def __init__(self):    #Inherit the good.
        #print "Creating Self"
        #print "Im born again"
        #needed by start_document
        self.appendix=0;
        self.toc=True


        #for statistics.
        self.chap=0;
        self.sec=False;
        
        self.char_print_flag=False;
        self.print_text=""
        return

    def escape(self,cstring):
        ret=""
        for i in cstring:
            if i=='&':
                i='\&' #this is latex!!
                flag=True
            ret=ret+i;
        return ret
                
    
    def setDocumentLocator(self,*locator):
        #print "Locater set doc"
        return


    def setDocumentHandler(self,locator):
        #print "setDocumentHandler:"
        #print str(locator);
        return

    def startDocument(self):
        #print "startingDocument"
        print "%This document is generated by LaTeX.py from contents.xml"
        print "%move to a different directory, before editing this file"
        print "\\documentclass{book}"
        print "\\usepackage{graphicx,}"
        print "\\begin{document}"
        return

    def endDocument(self):
         #print "endingDocument"                  
         print "\\end{document}"
         print "%<!-- generated by Python with SAX -->"
         print "%<!-- generated on "+str(time.asctime())+" -->"
         return

    def startPrefixMapping(self,prefix,inp):
        #print "prefixMapping"
        return

    def startElement(self,name,attrs):
        #print "startElement:",name
        self.sec=False
        self.char_print_flag=True;         
        if name == "Book":
            pass
        elif name == "Title":
            print "\\title{"+attrs.getValueByQName('name')+"}"
            print "\\date{"+str(time.asctime())+"}"
            
        elif name=="Toc":
            if(self.toc):
                print "\\tableofcontents"
                self.toc=False
        elif name == "Authors":
            print "\\author{"+attrs.getValueByQName('name')+"}\n"
        elif name == "Preface":
            print "\\Large{"+attrs.getValueByQName('name')+"}\n"
        elif name=="Copyrights":
            print "\\Large{"+name+attrs.getValueByQName('name')+"}\n"
        elif name=="Acknowledgements":
            print "\\textbf{"+ name+":"+attrs.getValueByQName('name')+"}\n"
        elif name=="Appendix":
            self.appendix=self.appendix+1
            if(1==self.appendix):
                print "\\appendix{"+attrs.getValueByQName('name')+"}\n"
            else:
                print "\\chapter{"+attrs.getValueByQName('name')+"}\n"
            self.print_text="%"
        elif name=="Glossary":
            print "\\chapter{"+name+""+attrs.getValueByQName('name')+"}\n"
        elif name=="Credits":
            print "\\chapter{"+name+""+attrs.getValueByQName('name')+"}\n"
        elif name=="Index":
            print "\\chapter{"+name+""+self.escape(attrs.getValueByQName('name'))+"}\n"
        elif name=="CHAP":
            self.chap=self.chap+1
            self.sec=0
            print "\\chapter{"+self.escape(attrs.getValueByQName('name'))+"}"
            self.sec=False
        elif name=="SEC":
            #self.sec=self.sec+1;
            self.sec=True
            self.print_text="\section{"
        return

    def endElement(self,name):
        #print "endElement:",name
        if (name=="Appendix"):
            self.print_text=self.print_text+"\n"
            print self.escape(self.print_text)
            self.print_text=""
        elif(name=="SEC" and self.sec):
            self.print_text=self.print_text+"}%ENDOFSEC\n"
            print self.escape(self.print_text)
            self.sec=False
            self.print_text=""
        return

if __name__ == "__main__":
    #create a new content handler.
    #start parsing the rss file.
    mxl=myxml()
    import sys;
    if(len(sys.argv) < 2):
        print "Usage: contents.py contents.xml"
        sys.exit(-1)
    #mxl=xml.sax.handler.ContentHandler()
    xml.sax.parse(sys.argv[1],mxl)


#DTD.
#Book
#\
#Title
#\name
#Toc
#\name
#Authors
#\name
#Preface
#\name
#Copyrights
#\name
#CHAP
#\name
##SEC
##/SEC
#/CHAP
#Appendix
#\name
#/Appendix
#Glossaray
#\name
#Credits
#\name
#Index
#\name
#/Book

#Thats All Folks!
# @      @  [Courtsey bugs bunny!]
#  \_||_/
#  (____)
