/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

int
main (int argc, char *argv[])
{
  GtkWidget *main_window, *statusbar, *text;
  GtkTextBuffer *buffer;
  GtkTextIter lineiter,enditer;

  GdkPixbuf *pic;
  GdkPixmap *pix;
  GdkColor c={0};
  GdkColormap *cmap;
  guint wt=0,ht=0;

#ifdef ENABLE_NLS
  bindtextdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
  bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
  textdomain (GETTEXT_PACKAGE);
#endif

  gtk_set_locale ();
  gtk_init (&argc, &argv);

  add_pixmap_directory ("/usr/share/pixmaps");

  main_window = create_main_window ();
  set_window_title (main_window);
  gtk_widget_show (main_window);

  /* We use the support function lookup_widget(), which is provided by Glade
     so you can get a pointer to any widget in a component, simply by passing
     any widget in the component, and the name of the widget you want.
     Here we pass the toplevel widget in the component, main_window, and
     we want to get the status bar widget which is called "statusbar1". */
  statusbar = lookup_widget (main_window, "statusbar1");
  gtk_statusbar_push (GTK_STATUSBAR (statusbar), 1,
		      "Welcome to the Glade Text Editor.");

  /* We also need to connect a signal to the GtkTextBuffer, to know when the
     text has changed. We can't connect the signal in Glade as GtkTextBuffer
     is not a widget. */
  text = lookup_widget (main_window, "text1");

  buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (text));
  gtk_text_buffer_create_tag(buffer,
			     "blue_fg",
			     "foreground",
			     "blue",
			     "background",
			     "yellow",
			     NULL);

  gtk_text_buffer_get_bounds(buffer,&lineiter,&enditer);
  gtk_text_buffer_apply_tag_by_name(buffer,"blue_fg",
				    &lineiter,&enditer);  

  /*
    pic=gdk_pixbuf_new_from_file("/usr/share/wallpapers/triplegears.jpg",NULL);
    gtk_text_buffer_insert_pixbuf(buffer,&lineiter,pic);//eeks!
    g_object_unref(pic);
  */


  pic=gdk_pixbuf_new_from_file("/usr/share/wallpapers/triplegears.jpg",NULL); 
  wt=gdk_pixbuf_get_width(pic);
  ht=gdk_pixbuf_get_height(pic);
  cmap=gdk_colormap_get_system();

  gdk_draw_pixbuf(GTK_WIDGET(text)->window,main_window->style->fg_gc[GTK_STATE_NORMAL],
		   pic,0,0,0,0,wt,ht,
		   GDK_RGB_DITHER_NONE,0,0);


  gtk_text_view_set_buffer(GTK_TEXT_VIEW (text),buffer);
  g_signal_connect (buffer, "changed", G_CALLBACK (on_text_changed), NULL);			     

  gtk_main ();
  return 0;
}

